Bug 1146569 (CVE-2019-15143)

Summary: VUL-0: CVE-2019-15143: djvulibre: In DjVuLibre 3.5.27, the bitmap reader component allows attackers to cause a denial-of-service error (resource exhaustion caused by a GBitmap:read_rle_raw infinite loop) by crafting a corrupted image file
Product: [Novell Products] SUSE Security Incidents Reporter: Wolfgang Frisch <wolfgang.frisch>
Component: IncidentsAssignee: Security Team bot <security-team>
Status: RESOLVED FIXED QA Contact: Security Team bot <security-team>
Severity: Normal    
Priority: P3 - Medium CC: smash_bz
Version: unspecified   
Target Milestone: ---   
Hardware: Other   
OS: Other   
URL: https://smash.suse.de/issue/240408/
Whiteboard: CVSSv2:NVD:CVE-2019-15143:4.3:(AV:N/AC:M/Au:N/C:N/I:N/A:P) CVSSv3:NVD:CVE-2019-15143:6.5:(AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H) CVSSv3:SUSE:CVE-2019-15143:5.5:(AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H)
Found By: Security Response Team Services Priority:
Business Priority: Blocker: ---
Marketing QA Status: --- IT Deployment: ---

Description Wolfgang Frisch 2019-08-21 09:16:04 UTC
CVE-2019-15143

In DjVuLibre 3.5.27, the bitmap reader component allows attackers to cause a
denial-of-service error (resource exhaustion caused by a GBitmap::read_rle_raw
infinite loop) by crafting a corrupted image file, related to
libdjvu/DjVmDir.cpp and libdjvu/GBitmap.cpp.

References:
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2019-15143
http://people.canonical.com/~ubuntu-security/cve/2019/CVE-2019-15143.html
http://www.cvedetails.com/cve/CVE-2019-15143/
http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-15143
https://sourceforge.net/p/djvu/djvulibre-git/ci/b1f4e1b2187d9e5010cd01ceccf20b4a11ce723f/
https://sourceforge.net/p/djvu/bugs/297/
Comment 1 Wolfgang Frisch 2019-08-21 09:29:11 UTC
Following an investigation of the source code, I conclude that all supported versions of djvulibre are affected:

SUSE:SLE-11:Update
SUSE:SLE-12:Update
SUSE:SLE-15:Update
Comment 2 Petr Gajdos 2019-09-02 09:22:14 UTC
BEFORE

devel,15,12/djvulibre

$ cjb2 h01.txt /dev/null
<loops>

11/djvulibre

$ cjb2 h01.txt /dev/null
*** [1-13807] RLE: synchronization lost.
*** (GBitmap.cpp:897)
*** 'void DJVU::GBitmap::read_rle_raw(DJVU::ByteStream&)'

$
[testcase does not exhibit the issue]

PATCH

referenced in comment 0
even applicable for 11/djvulibre

AFTER

devel,15,12,11/djvulibre

$ cjb2 h01.txt /dev/null
*** Unexpected End Of File.
*** (GBitmap.cpp:892)
*** 'void DJVU::GBitmap::read_rle_raw(DJVU::ByteStream&)'

$
[exits immediately, 11/djvulibre changes the error message]
Comment 3 Petr Gajdos 2019-09-02 09:23:47 UTC
Will submit for devel,15,12,11/djvulibre.
Comment 4 Petr Gajdos 2019-09-02 12:18:15 UTC
I believe all fixed.
Comment 5 Swamp Workflow Management 2019-09-02 12:50:06 UTC
This is an autogenerated message for OBS integration:
This bug (1146569) was mentioned in
https://build.opensuse.org/request/show/727759 Factory / djvulibre
Comment 7 Swamp Workflow Management 2019-09-24 13:21:24 UTC
SUSE-SU-2019:2444-1: An update that fixes four vulnerabilities is now available.

Category: security (moderate)
Bug References: 1146569,1146571,1146572,1146702
CVE References: CVE-2019-15142,CVE-2019-15143,CVE-2019-15144,CVE-2019-15145
Sources used:
SUSE Linux Enterprise Software Development Kit 12-SP4 (src):    djvulibre-3.5.25.3-5.3.1
SUSE Linux Enterprise Server 12-SP4 (src):    djvulibre-3.5.25.3-5.3.1
SUSE Linux Enterprise Desktop 12-SP4 (src):    djvulibre-3.5.25.3-5.3.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 8 Swamp Workflow Management 2019-09-24 19:11:26 UTC
SUSE-SU-2019:2452-1: An update that fixes four vulnerabilities is now available.

Category: security (moderate)
Bug References: 1146569,1146571,1146572,1146702
CVE References: CVE-2019-15142,CVE-2019-15143,CVE-2019-15144,CVE-2019-15145
Sources used:
SUSE Linux Enterprise Module for Packagehub Subpackages 15 (src):    djvulibre-3.5.27-3.3.1
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15-SP1 (src):    djvulibre-3.5.27-3.3.1
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15 (src):    djvulibre-3.5.27-3.3.1
SUSE Linux Enterprise Module for Desktop Applications 15-SP1 (src):    djvulibre-3.5.27-3.3.1
SUSE Linux Enterprise Module for Desktop Applications 15 (src):    djvulibre-3.5.27-3.3.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 9 Swamp Workflow Management 2019-09-30 10:11:26 UTC
openSUSE-SU-2019:2217-1: An update that fixes four vulnerabilities is now available.

Category: security (moderate)
Bug References: 1146569,1146571,1146572,1146702
CVE References: CVE-2019-15142,CVE-2019-15143,CVE-2019-15144,CVE-2019-15145
Sources used:
openSUSE Leap 15.0 (src):    djvulibre-3.5.27-lp150.2.3.1
Comment 10 Swamp Workflow Management 2019-09-30 19:13:11 UTC
openSUSE-SU-2019:2219-1: An update that fixes four vulnerabilities is now available.

Category: security (moderate)
Bug References: 1146569,1146571,1146572,1146702
CVE References: CVE-2019-15142,CVE-2019-15143,CVE-2019-15144,CVE-2019-15145
Sources used:
openSUSE Leap 15.1 (src):    djvulibre-3.5.27-lp151.3.3.1
Comment 11 Marcus Meissner 2019-10-20 08:15:12 UTC
done